diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
new file mode 100644
index f36afa5..87095e8
*** a/src/backend/access/common/reloptions.c
--- b/src/backend/access/common/reloptions.c
*************** static relopt_int intRelOpts[] =
*** 231,288 ****
  	},
  	{
  		{
- 			"autovacuum_freeze_min_age",
- 			"Minimum age at which VACUUM should freeze a table row, for autovacuum",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		},
- 		-1, 0, 1000000000
- 	},
- 	{
- 		{
- 			"autovacuum_multixact_freeze_min_age",
- 			"Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		},
- 		-1, 0, 1000000000
- 	},
- 	{
- 		{
- 			"autovacuum_freeze_max_age",
- 			"Age at which to autovacuum a table to prevent transaction ID wraparound",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		},
- 		-1, 100000, 2000000000
- 	},
- 	{
- 		{
- 			"autovacuum_multixact_freeze_max_age",
- 			"Multixact age at which to autovacuum a table to prevent multixact wraparound",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		},
- 		-1, 10000, 2000000000
- 	},
- 	{
- 		{
- 			"autovacuum_freeze_table_age",
- 			"Age at which VACUUM should perform a full table sweep to freeze row versions",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		}, -1, 0, 2000000000
- 	},
- 	{
- 		{
- 			"autovacuum_multixact_freeze_table_age",
- 			"Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
- 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
- 			ShareUpdateExclusiveLock
- 		}, -1, 0, 2000000000
- 	},
- 	{
- 		{
  			"log_autovacuum_min_duration",
  			"Sets the minimum execution time above which autovacuum actions will be logged",
  			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
--- 231,236 ----
*************** static relopt_int intRelOpts[] =
*** 329,347 ****
  		},
  		-1, 0, 1024
  	},
- 
  	/* list terminator */
  	{{NULL}}
  };
  
- 
  static relopt_int64 int64RelOpts[] =
  {
  	/* list terminator */
  	{{NULL}}
  };
  
- 
  static relopt_real realRelOpts[] =
  {
  	{
--- 277,346 ----
  		},
  		-1, 0, 1024
  	},
  	/* list terminator */
  	{{NULL}}
  };
  
  static relopt_int64 int64RelOpts[] =
  {
+ 	{
+ 		{
+ 			"autovacuum_freeze_min_age",
+ 			"Minimum age at which VACUUM should freeze a table row, for autovacuum",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(0), INT64CONST(1000000000)
+ 	},
+ 	{
+ 		{
+ 			"autovacuum_multixact_freeze_min_age",
+ 			"Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(0), INT64CONST(1000000000)
+ 	},
+ 	{
+ 		{
+ 			"autovacuum_freeze_max_age",
+ 			"Age at which to autovacuum a table to prevent transaction ID wraparound",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(100000), INT64CONST(2000000000)
+ 	},
+ 	{
+ 		{
+ 			"autovacuum_multixact_freeze_max_age",
+ 			"Multixact age at which to autovacuum a table to prevent multixact wraparound",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(10000), INT64CONST(2000000000)
+ 	},
+ 	{
+ 		{
+ 			"autovacuum_freeze_table_age",
+ 			"Age at which VACUUM should perform a full table sweep to freeze row versions",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(0), INT64CONST(2000000000)
+ 	},
+ 	{
+ 		{
+ 			"autovacuum_multixact_freeze_table_age",
+ 			"Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
+ 			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+ 			ShareUpdateExclusiveLock
+ 		},
+ 		INT64CONST(-1), INT64CONST(0), INT64CONST(2000000000)
+ 	},
  	/* list terminator */
  	{{NULL}}
  };
  
  static relopt_real realRelOpts[] =
  {
  	{
*************** initialize_reloptions(void)
*** 474,479 ****
--- 473,484 ----
  								   int64RelOpts[i].gen.lockmode));
  		j++;
  	}
+ 	for (i = 0; int64RelOpts[i].gen.name; i++)
+ 	{
+ 		Assert(DoLockModesConflict(int64RelOpts[i].gen.lockmode,
+ 								   int64RelOpts[i].gen.lockmode));
+ 		j++;
+ 	}
  	for (i = 0; realRelOpts[i].gen.name; i++)
  	{
  		Assert(DoLockModesConflict(realRelOpts[i].gen.lockmode,
*************** default_reloptions(Datum reloptions, boo
*** 1400,1416 ****
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, vacuum_cost_delay)},
  		{"autovacuum_vacuum_cost_limit", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, vacuum_cost_limit)},
! 		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_min_age)},
! 		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_max_age)},
! 		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_table_age)},
! 		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_min_age)},
! 		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_max_age)},
! 		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_table_age)},
  		{"log_autovacuum_min_duration", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, log_min_duration)},
--- 1405,1421 ----
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, vacuum_cost_delay)},
  		{"autovacuum_vacuum_cost_limit", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, vacuum_cost_limit)},
! 		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_min_age)},
! 		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_max_age)},
! 		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, freeze_table_age)},
! 		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_min_age)},
! 		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_max_age)},
! 		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT64,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, multixact_freeze_table_age)},
  		{"log_autovacuum_min_duration", RELOPT_TYPE_INT,
  		offsetof(StdRdOptions, autovacuum) +offsetof(AutoVacOpts, log_min_duration)},
diff --git a/src/backend/access/gist/gist.c b/src/backend/access/gist/gist.c
new file mode 100644
index 6593771..239de1a
*** a/src/backend/access/gist/gist.c
--- b/src/backend/access/gist/gist.c
*************** gistdoinsert(Relation r, IndexTuple itup
*** 641,646 ****
--- 641,647 ----
  
  		stack->page = (Page) BufferGetPage(stack->buffer);
  		stack->lsn = PageGetLSN(stack->page);
+ 		elog(LOG, "LSN = " UINT64_FORMAT, stack->lsn);
  		Assert(!RelationNeedsWAL(state.r) || !XLogRecPtrIsInvalid(stack->lsn));
  
  		/*
diff --git a/src/backend/access/hash/hash_xlog.c b/src/backend/access/hash/hash_xlog.c
new file mode 100644
index 0ea11b2..88ac133
*** a/src/backend/access/hash/hash_xlog.c
--- b/src/backend/access/hash/hash_xlog.c
***************
*** 18,23 ****
--- 18,24 ----
  #include "access/bufmask.h"
  #include "access/hash.h"
  #include "access/hash_xlog.h"
+ #include "access/htup_details.h"
  #include "access/xlogutils.h"
  #include "access/xlog.h"
  #include "access/transam.h"
*************** hash_xlog_vacuum_get_latestRemovedXid(XL
*** 961,967 ****
  	ItemId		iitemid,
  				hitemid;
  	IndexTuple	itup;
- 	HeapTupleHeader htuphdr;
  	BlockNumber hblkno;
  	OffsetNumber hoffnum;
  	TransactionId latestRemovedXid = InvalidTransactionId;
--- 962,967 ----
*************** hash_xlog_vacuum_get_latestRemovedXid(XL
*** 1061,1068 ****
  		 */
  		if (ItemIdHasStorage(hitemid))
  		{
! 			htuphdr = (HeapTupleHeader) PageGetItem(hpage, hitemid);
! 			HeapTupleHeaderAdvanceLatestRemovedXid(htuphdr, &latestRemovedXid);
  		}
  		else if (ItemIdIsDead(hitemid))
  		{
--- 1061,1072 ----
  		 */
  		if (ItemIdHasStorage(hitemid))
  		{
! 			HeapTupleData htup;
! 
! 			htup.t_data = (HeapTupleHeader) PageGetItem(hpage, hitemid);
! 			HeapTupleCopyBaseFromPage(&htup, hpage);
! 
! 			HeapTupleHeaderAdvanceLatestRemovedXid(&htup, &latestRemovedXid);
  		}
  		else if (ItemIdIsDead(hitemid))
  		{
